/*==========================================================================  
by "Akshay Momaya"
for "Mission Critical" ( youtube )
******subscribe for more ARDUINO projects and tutorials******
https://www.youtube.com/channel/UCM6rbuieQBBLFsxszWA85AQ?sub_confirmation=1
==========================================================================*/



#include <SPI.h>
#include <Wire.h>
#include <Adafruit_GFX.h>
#include <Adafruit_SSD1306.h>

#define OLED_RESET 4
Adafruit_SSD1306 display(OLED_RESET);


const int trigPin = 4;
const int echoPin = 3;

// defines variables
long duration;
int distance;

void setup() 
{
pinMode(trigPin, OUTPUT); // Sets the trigPin as an Output
pinMode(echoPin, INPUT); // Sets the echoPin as an Input
Serial.begin(9600); // Starts the serial communication

pinMode(5,OUTPUT);     //virtual power pin
digitalWrite(5,HIGH); // virtual power pin
pinMode(2,OUTPUT);     //virtual power pin
digitalWrite(2,LOW);

display.begin(SSD1306_SWITCHCAPVCC, 0x3C); //oled setup ( watch full oled tutorial on my channel MISSION CRITICAL )

display.clearDisplay(); //clear display
display.setTextSize(1); //set text size
display.setTextColor(WHITE); 
display.setCursor(0,0);  //Cursor Position
display.println("Electronic Scale by:"); //Start-Up Animation
display.setTextSize(1);
display.setTextColor(WHITE);
display.setCursor(0,15);
display.println("MISSION CRITICAL");
display.display();
delay(1000);

display.clearDisplay();
}

void loop() 

{
                                   // Clears the trigPin
digitalWrite(trigPin, LOW);
delayMicroseconds(2);
                                    // Sets the trigPin on HIGH state for 10 micro seconds
digitalWrite(trigPin, HIGH);
delayMicroseconds(10);
digitalWrite(trigPin, LOW);
                                     // Reads the echoPin, returns the sound wave travel time in microseconds
duration = pulseIn(echoPin, HIGH);
                                     // Calculating the distance
distance= duration*0.034/2;
                                   // Prints the distance on the Serial Monitor
Serial.print("Distance: ");
Serial.println(distance);
                                   //display results on OLED
  display.setTextSize(1);
  display.setTextColor(WHITE);
  display.setCursor(0,0);
  display.println("Electronic Scale");
  display.display();
  display.setTextSize(2);
  display.setTextColor(WHITE);
  display.setCursor(70,15);
  display.println("cm");
  display.display();
  display.setTextSize(3);
  display.setTextColor(WHITE);
  display.setCursor(12,10);
  display.println(distance);
  display.display();
  
  delay(500);
  display.clearDisplay();

}
